unit bmp8bit;

interface

uses Windows, Classes, SysUtils, Graphics;

type
	tab_tcol256    = array [0..255] of TColor;


	procedure SaveBMP(bmp: TBitmap);


implementation

var
  nc: Integer;

  npal: tab_tcol256;


procedure addPal(cl: TColor);
var x: integer;
begin

  for x:=0 to nc-1 do
   if npal[x] = cl then exit;

  if nc < 256 then begin
    npal[nc]:=cl;
    inc(nc);
   end;

end;


procedure SaveBMP(bmp: TBitmap);
(*----------------------------------------------------------------------------*)
(* SAVE BMP (indexed 8bit per pixel)                                          *)
(*----------------------------------------------------------------------------*)
type
  ___bmpHeader = packed record
                    bftype:word;
                    bfsize:longint;
                    bfreserv1:word;
                    bfreserv2:word;
                    bfoffbits:longint;

                    bisize:longint;
                    biwidth:longint;
                    biheight:longint;
                    biplanes:word;
                    bibitcount:word;
                    bicompress:longint;
                    bisizeimage:longint;
                    biXPelsPerMeter:longint;
                    biYPelsPerMeter:longint;
                    biClrUsed:longint;
                    biClrImportant:longint;
                 end;

var i,j, x, FileHandle: integer;
    bmpheader: ___bmpHeader;
    temp: array [0..511] of byte;
    v: byte;
    cl: TColor;
begin


 with bmpheader do begin
  bftype:=256*ord('M')+ord('B');
  bisize:=40;
  biwidth:=bmp.Width;              { szerokosc w pixlach }
  biheight:=bmp.Height;               { wysokosc }
  bfoffbits:=14+bisize+1024;
  bisizeimage:=biwidth*biheight;
  bfsize:=bfoffbits+bisizeimage;

  biClrUsed:=$100;         { liczba kolorow = max 256 }
  biClrImportant:=0;
  biXPelsPerMeter:=0;
  biYPelsPerMeter:=0;
  bfreserv1:=0;
  bfreserv2:=0;
  bicompress:=0;
  biplanes:=1;
  bibitcount:=8;           { liczba bitow na pixel }
 end;


 nc:=0;

 for i:=0 to 255 do npal[i]:=0;     // init palety


for j:=0 to bmp.Height-1 do
 for i:=0 to bmp.Width-1 do
  addPal(bmp.Canvas.Pixels[i,j] );


//  writeln(nc);


 FileHandle := FileCreate('@temp@.bmp');
 try

 FileWrite(FileHandle, bmpheader, sizeof(bmpheader));

 for i:=0 to 255 do begin
  temp[0]:=GetBValue(npal[i]);
  temp[1]:=GetGValue(npal[i]);
  temp[2]:=GetRValue(npal[i]);
  temp[3]:=0;

  FileWrite(FileHandle, temp,4);
 end;


 for j:=bmp.Height-1 downto 0 do begin
  for i:=0 to bmp.Width-1 do begin

   cl:=bmp.Canvas.Pixels[i,j];

   v:=0;
   for x:=0 to nc-1 do
    if npal[x]=cl then begin v:=x; Break end;

   temp[i]:=v;
  end;

  FileWrite(FileHandle, temp, bmp.Width);
 end;

 finally
  FileClose(FileHandle);
 end;

end;


end.